unit UnitMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, TeEngine, Series, TeeProcs, Chart, ExtCtrls, Menus, ComCtrls, UnitDFT,
  StdCtrls,ShellApi;
type pTRE = ^TRichEdit;
type pTMS = ^TMemoryStream;

type
  TForm1 = class(TForm)
    StatusBar1: TStatusBar;
    MainMenu1: TMainMenu;
    NFile: TMenuItem;
    NLoad: TMenuItem;
    NSave: TMenuItem;
    NExit: TMenuItem;
    NAbout: TMenuItem;
    Timer1: TTimer;
    PanelLeft: TPanel;
    PanelMain: TPanel;
    PanelChart: TPanel;
    PanelProc: TPanel;
    PanelRight: TPanel;
    SplitterRight: TSplitter;
    ChartSpectr: TChart;
    ChartF: TChart;
    OpenDialog1: TOpenDialog;
    Series1: TAreaSeries;
    Series2: TLineSeries;
    PanelSpectr: TPanel;
    PanelF: TPanel;
    GroupBox1: TGroupBox;
    CheckBoxAutoX: TCheckBox;
    EditMaxX: TEdit;
    ButtonXAxis: TButton;
    GroupBox2: TGroupBox;
    EditScaleX: TEdit;
    Label1: TLabel;
    ButtonDataRefresh: TButton;
    CheckBoxH0: TCheckBox;
    Label3: TLabel;
    EditADC: TEdit;
    ProgressBar1: TProgressBar;
    GroupBox3: TGroupBox;
    Label4: TLabel;
    EditKmax: TEdit;
    GroupBox4: TGroupBox;
    Label5: TLabel;
    Label6: TLabel;
    EditStartPattern: TEdit;
    EditWidthPattern: TEdit;
    ButtonStartAutoKor: TButton;
    Series3: TLineSeries;
    CheckBoxViewF: TCheckBox;
    CheckBoxViewS: TCheckBox;
    N1: TMenuItem;
    NSpectr: TMenuItem;
    PanelAbout: TPanel;
    Button1: TButton;
    Memo1: TMemo;
    Panel1: TPanel;
    Panel2: TPanel;
    Splitter1: TSplitter;
    Panel3: TPanel;
    Panel4: TPanel;
    RichEdit1: TRichEdit;
    RichEdit2: TRichEdit;
    NLoadPat: TMenuItem;
    N4: TMenuItem;
    Label2: TLabel;
    Label7: TLabel;
    GroupBox5: TGroupBox;
    Label8: TLabel;
    EditADCpat: TEdit;
    CheckBoxViewPat: TCheckBox;
    Label9: TLabel;
    GroupBox6: TGroupBox;
    RadioButton1: TRadioButton;
    CheckBoxViewPatKor: TCheckBox;
    ButtonStartPatKor: TButton;
    ButtonGraphPat: TButton;
    Series4: TLineSeries;
    N3: TMenuItem;
    NGen: TMenuItem;
    NKorr: TMenuItem;
    procedure NExitClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure NLoadClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ButtonXAxisClick(Sender: TObject);
    procedure ButtonDataRefreshClick(Sender: TObject);
    procedure RichEdit1Change(Sender: TObject);
    procedure ButtonStartAutoKorClick(Sender: TObject);
    procedure CheckBoxMarkClick(Sender: TObject);
    procedure Series2Click(Sender: TChartSeries; ValueIndex: Integer;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure Series3Click(Sender: TChartSeries; ValueIndex: Integer;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure CheckBoxViewFClick(Sender: TObject);
    procedure CheckBoxViewSClick(Sender: TObject);
    procedure NAboutClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure NSpectrClick(Sender: TObject);
    procedure ButtonStartPatKorClick(Sender: TObject);
    procedure ButtonGraphPatClick(Sender: TObject);
    procedure RichEdit2Change(Sender: TObject);
    procedure CheckBoxViewPatClick(Sender: TObject);
    procedure NGenClick(Sender: TObject);
    procedure CheckBoxViewPatKorClick(Sender: TObject);
    procedure NKorrClick(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
    procedure RefreshStringData;
    procedure RefreshStringPat;
    procedure FiltrData(pRE:pTRE;pMS:pTMS; var count_line:longint; var sum:real; var poserr:integer);
    procedure PrepareFint;
    procedure DrawPat;
    procedure CreateSpectr;
    procedure SamplCorrelation;
    procedure PirsonCorrelation;
    procedure SetParamSinCos;
    procedure Export_res(ff:integer);
  end;

var
  Form1: TForm1;
  DFT:TDFT;
  ds_sys:char;// DecimalSeparator   
  DataStream: TMemoryStream;
  Pattern: TMemoryStream;
  Pattern_int: TMemoryStream;
  ChangStringData,ChangStringPat: boolean;
  ErrorStringData,ErrorStringPat: longint;
  Save_Cursor:TCursor;
  StartPattern,WidthPattern_avto,WidthPattern_pat:longint;
  FaktPrepareFint,FaktPrepareFPat:boolean;
  ADC_pat:integer;
  avg_pat:integer;

  ScaleX:real;
  tt1,tt2:longint;
implementation

{$R *.dfm}

procedure TForm1.NExitClick(Sender: TObject);
begin
 Close;
end;


procedure TForm1.DrawPat;
var
 n:word;
 pr:real;
 pr_int,S,Sr:integer;
 avg:real;
 sum:longint;

begin


 Sr:=sizeof(pr);
 S:= sizeof(pr_int);
 Pattern.Seek(0, soFromBeginning);
 Pattern_int.Seek(0, soFromBeginning);
 avg:=0;
 sum:=0;
 for n:=0 to WidthPattern_pat-1 do
  begin
   Pattern.ReadBuffer(pr,Sr);
   pr_int:= round(pr*ADC_pat - avg);
   sum:=sum + pr_int;
   Pattern_int.WriteBuffer(pr_int,S);
   ChartF.Series[2].AddXY(n,pr_int,'');
  end;
 avg_pat:=round(sum / WidthPattern_pat);
 FaktPrepareFpat:=true;

end;


procedure TForm1.PrepareFint;
var
 n:word;
 pr:real;
 f:real;
 pr_int,S,Sr:integer;
 st:string;
 avg:real;

 cod:integer;
begin
 S:= sizeof(pr_int);
 DFT.Fint.Seek(0,soFromBeginning);
 Sr:=sizeof(pr);

 avg:=0;
 if CheckBoxH0.Checked then avg:=DFT.Avg*DFT.ADC;

 DataStream.Seek(0, soFromBeginning);
 for n:=0 to DFT.nmax-1 do
  begin
   DataStream.ReadBuffer(pr,Sr);
   pr_int:= round(pr*DFT.ADC - avg);
   DFT.fint.WriteBuffer(pr_int,S);

   Val(EditScaleX.Text,ScaleX,cod);
    st:='';
    ChartF.Series[0].AddXY(n,pr_int,st);

  end;

 FaktPrepareFint:=true;

end;

procedure TForm1.CreateSpectr;
var
 k:word;
 Re,Im,Ampl:real;
 F:integer;
 st:string;
 pr:real;
begin
// ChartSpectr.Series[0].Clear;
 for k:=0 to DFT.kmax-1 do
 begin
   Re:=DFT.ReDFTQ(k);
   Im:=DFT.ImDFTQ(k);
   Ampl:=Sqrt(Re*Re+Im*Im);
   pr:=k*ScaleX/DFT.nmax;

 //  F:= round(pr);
   st:=format('%0.2f',[pr]);
   ChartSpectr.Series[0].AddXY(k,Ampl,st);

 end;

end;


procedure TForm1.FormCreate(Sender: TObject);
  var st:string;
begin
 DFT := TDFT.Create;
 CheckBoxAutoX.Checked:=true;
 ChartF.BottomAxis.Automatic:=CheckBoxAutoX.Checked;
// EditMaxX.Enabled:= not CheckBoxAutoX.Checked;
 DataStream := TMemoryStream.Create;
 Pattern := TMemoryStream.Create;
 Pattern_int := TMemoryStream.Create;
 ds_sys:= DecimalSeparator;
 DecimalSeparator:=ds_sys;

 RichEdit1.Clear;
 RichEdit2.Clear;
 FaktPrepareFint:=false;
 FaktPrepareFPat:=false;
 ChangStringData := true;

end;
procedure TForm1.FiltrData(pRE:pTRE;pMS:pTMS; var count_line:longint; var sum:real; var poserr:integer);
var
  n:longint;
  pr:real;
  Ll:integer;
  cod:integer;
  b:byte;
  st:string;
begin
    sum:=0;
    count_line:=0; //  
    pMS^.Seek(0, soFromBeginning);
    ErrorStringData:=-1;
    if pRE^.Lines.Count = 0 then ErrorStringData:=0;
    ProgressBar1.Max:= pRE^.Lines.Count;
    ProgressBar1.step:=10;
    ProgressBar1.Position:=0;

    for n:=0 to pRE^.Lines.Count - 1 do
    begin
      st:=pRE^.Lines[n];
      Ll:=Length(st);
      if st = '' then
       begin
        ErrorStringData:=n;
        break;
       end;
      if st[Ll] = #9 then Delete(st,Ll,1);
      Ll:=Length(st);
      b:=ord(st[Ll]);
      if b = 32 then Delete(st,Ll,1);
      Val(st,pr,poserr);
      if poserr = 0 then
      begin
       pMS^.WriteBuffer(pr,Sizeof(pr));
       sum:=sum+pr;
       count_line:=count_line+1;
       ProgressBar1.Position:=count_line;
      end else
      if st[poserr] in ['.',','] then
       begin
        if st[poserr] = '.' then st[poserr]:=',' else st[poserr]:='.';
        Val(st,pr,poserr);
        pMS^.WriteBuffer(pr,Sizeof(pr));
        sum:=sum+pr;
        count_line:=count_line+1;
        ProgressBar1.Position:=count_line;
       end else
        if pRE^.Lines[n] <> '' then
         begin
          ErrorStringData:=n;
          break;
         end;
    end;


end;


procedure TForm1.RefreshStringPat;
var
  Ls:longint;
  sum:real;
  codview:integer;
  ErrorSel,CountChar:longint;
  st:string;
begin
   Save_Cursor := Screen.Cursor;
   Screen.Cursor := crHourGlass;    { Show hourglass cursor }
   codview:=0;
   try
    FiltrData(@RichEdit2,@Pattern,Ls,sum,codview);
    WidthPattern_pat:=Ls;
    ErrorStringPat:=ErrorStringData;
    ErrorStringData:=-1;
    ProgressBar1.Position:=0;

    if ErrorStringPat <> -1 then
      begin
        StatusBar1.Panels[2].Text:=':    '+inttostr(ErrorStringPat+1)+'   '+inttostr(codview);
        RichEdit2.SetFocus;
        RichEdit2.SelectAll;
        CountChar:=RichEdit2.SelLength;
        st := RichEdit2.Lines[ErrorStringPat];
        st:=copy(st,codview,1);
        ErrorSel:=RichEdit2.FindText(st,0,CountChar,[stMatchCase]);
        RichEdit2.SelStart:=ErrorSel;
        RichEdit2.SelLength:=length(st);
      end
        else
      begin
        StatusBar1.Panels[2].Text:='';
        ChangStringPat := false;
      end;

   finally
    Screen.Cursor := Save_Cursor;
   end;


end;

procedure TForm1.RefreshStringData;
var
  Ls:longint;
  sum:real;
  cod,codview:integer;
  ErrorSel,CountChar:longint;
  st:string;
  adc:integer;

begin
   Save_Cursor := Screen.Cursor;
   Screen.Cursor := crHourGlass;    { Show hourglass cursor }
   codview:=0;
   try
//**********************************************************
    FiltrData(@RichEdit1,@DataStream,Ls,sum, codview);
    ProgressBar1.Position:=0;
    if Ls <> 0 then
    begin
     DFT.nmax:=Ls;
     DFT.Avg:=sum / Ls;
    end else
    begin
      DFT.nmax:=1;
      DFT.Avg:=0;
    end;

    Val(EditADC.Text,adc,cod);
    if cod = 0 then DFT.ADC:=adc;

    StatusBar1.Panels[0].Text:=' : '+inttostr(DFT.nmax);
    StatusBar1.Panels[1].Text:=': '+ FloatToStrF(DFT.Avg,ffGeneral,4,4)+' / '+ inttostr(trunc(DFT.Avg*DFT.ADC));
    if ErrorStringData <> -1 then
      begin
        StatusBar1.Panels[2].Text:=':    '+inttostr(ErrorStringData+1)+'   '+inttostr(codview);
        RichEdit1.SetFocus;
        RichEdit1.SelectAll;
        CountChar:=RichEdit1.SelLength;
        st := RichEdit1.Lines[ErrorStringData];
        st:=copy(st,codview,1);
        ErrorSel:=RichEdit1.FindText(st,0,CountChar,[stMatchCase]);
        RichEdit1.SelStart:=ErrorSel;
        RichEdit1.SelLength:=length(st);
      end
        else
      begin
       StatusBar1.Panels[2].Text:='';
       ChangStringData := false;
      end;

//**********************************************************
   finally
    Screen.Cursor := Save_Cursor;
   end;

end;

procedure TForm1.NLoadClick(Sender: TObject);
var n,pos1,pos2,CountChar:longint;
st:string;
temp_string: array[0..15] of Char;
done:boolean;
f: TextFile;
atr:word;
cod:integer;
pr:real;
AppPath:string;
begin

 AppPath := AnsiUpperCase(ExtractFilePath(ParamStr(0)));
 OpenDialog1.InitialDir:=AppPath;

 if OpenDialog1.Execute then
  begin

   RichEdit1.Clear;
   RichEdit1.Lines.LoadFromFile(OpenDialog1.FileName);
   n:=0;

   RichEdit1.SetFocus;
   RichEdit1.SelectAll;
   CountChar:=RichEdit1.SelLength;


   st:='Hz):';
   pos1:=RichEdit1.FindText(st,0,CountChar,[stMatchCase]);
   pos2:=RichEdit1.FindText(#9,pos1,CountChar,[stMatchCase]);

   if ((pos1 < 0) or (pos2 < 0 )) then EditScaleX.Text :='1'
   else
   begin
     RichEdit1.SetFocus;
     RichEdit1.SelStart:=pos1+Length(st)+1;
     RichEdit1.SelLength:=pos2-RichEdit1.SelStart;

     RichEdit1.CopyToClipboard;
     EditScaleX.Text:='';
     EditScaleX.PasteFromClipboard;

     Val(EditScaleX.Text,pr,cod);
     if cod <> 0 then EditScaleX.Text :='1';
   end;

   st:='*******';
   pos1:= RichEdit1.FindText(st,0,CountChar,[stMatchCase]);
   if pos1 >=0 then
   begin
     RichEdit1.SelStart:=0;
     RichEdit1.SelLength:=pos1+Length(st)+2;
     RichEdit1.ClearSelection;
   end;
{
   done:=false;
   repeat
    st:= RichEdit1.Lines[0];
    Val(st,pr,cod);
    if cod = 0 then break;
    if st[1] = '*' then done:=true;
    RichEdit1.Lines.Delete(0);
    inc(n);
    if ((n >= RichEdit1.Lines.Count) or (n > 20)) then done:=true;
   until done;
}
   RichEdit1.SetFocus;
   RefreshStringData;
  end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   FreeAndNil(DataStream);
   FreeAndNil(DFT.sin_nmax);
   FreeAndNil(DFT.cos_nmax);
   FreeAndNil(DFT.fint);
   FreeAndNil(Pattern);
   FreeAndNil(Pattern_int);
 end;

procedure TForm1.ButtonXAxisClick(Sender: TObject);
var cod:integer;
i:integer;
begin

 if CheckBoxAutoX.Checked then ChartF.BottomAxis.Automatic:=CheckBoxAutoX.Checked
 else
 begin
  ChartF.BottomAxis.Automatic:=false;
  Val(EditMaxX.Text,i,cod);
  if cod = 0 then ChartF.BottomAxis.Maximum:=i;
 end;

end;

procedure TForm1.SetParamSinCos;
var k,n:integer;
    pr:integer;
    S:integer;
begin
 DFT.T := 2*pi/DFT.nmax;
 DFT.sin_nmax.Seek(0, soFromBeginning);
 DFT.cos_nmax.Seek(0, soFromBeginning);

 S:=Sizeof(pr);
 ProgressBar1.Max:= DFT.kmax;
 ProgressBar1.step:=1;

 for k:=0 to DFT.kmax-1 do
  for n:=0 to DFT.nmax-1 do
   begin
    DFT.nkT:=n*k*DFT.T;
    ProgressBar1.Position:=k;
    pr:=round(sin(DFT.nkT)*DFT.ADC);
    DFT.sin_nmax.WriteBuffer(pr,S);
    pr:=round(cos(DFT.nkT)*DFT.ADC);
    DFT.cos_nmax.WriteBuffer(pr,S);
   end;

 ProgressBar1.Position:=0;
end;


procedure TForm1.ButtonGraphPatClick(Sender: TObject);
var adc,cod:integer;
begin

 Val(EditADCpat.Text,adc,cod);
 if cod = 0 then ADC_pat:=adc else ADC_pat:=1;

 if ChangStringPat then RefreshStringPat;
 ChartF.Series[2].Clear;
 if ErrorStringPat = -1 then
   begin
    DrawPat;
   end;

end;

procedure TForm1.ButtonDataRefreshClick(Sender: TObject);
var cod:integer;
adc:integer;
begin

    Val(EditKmax.Text,adc,cod);
    if cod = 0 then DFT.kmax:=adc else DFT.kmax:=32;
    if adc <= 0 then DFT.kmax:=32;

    Val(EditADC.Text,adc,cod);
    if cod = 0 then DFT.ADC:=adc else DFT.ADC:=1;

    if ChangStringData then RefreshStringData;

    ChartF.Series[0].Clear;
    ChartF.Series[1].Clear;
    ChartSpectr.Series[0].Clear;

    if ErrorStringData = -1 then
    begin
      tt1:=gettickcount;
      SetParamSinCos;// 1  sin
      tt2:=abs(gettickcount - tt1);
      statusbar1.Panels[3].Text:=inttostr(tt2);

      tt1:=gettickcount;
      PrepareFint; // 2
      tt2:=abs(gettickcount - tt1);
      statusbar1.Panels[3].Text:=statusbar1.Panels[3].Text+'   '+inttostr(tt2);

      tt1:=gettickcount;
      CreateSpectr; // 3
      tt2:=abs(gettickcount - tt1);
      statusbar1.Panels[3].Text:=statusbar1.Panels[3].Text+'   '+inttostr(tt2);
    end;
    StatusBar1.Panels[1].Text:=': '+ FloatToStrF(DFT.Avg,ffGeneral,4,4)+' / '+ inttostr(trunc(DFT.Avg*DFT.ADC));

end;

procedure TForm1.RichEdit1Change(Sender: TObject);
begin
  ChangStringData := true;
end;

procedure TForm1.RichEdit2Change(Sender: TObject);
begin
  ChangStringPat := true;
end;

procedure TForm1.PirsonCorrelation;
var
 n:longint;
 pn:integer;
 pr_int,pat_int:integer;
 Sr:integer;
 sum,dx,dy,mx,my:longint;
 cov:integer;
 cor:real;
 st:string;

 avg_dat:longint;

begin

//  ,   
 Pattern_int.Seek(0, soFromBeginning);
 Sr:=sizeof(pr_int);

 for n:=0 to DFT.nmax-WidthPattern_pat do
  begin
   sum:=0;
   dx:=0;
   dy:=0;
   DFT.fint.Seek(n*Sr, soFromBeginning);
   for pn:=0 to WidthPattern_pat-1 do
    begin
     DFT.fint.ReadBuffer(pr_int,Sr);
     sum:=sum + pr_int;
    end;
   avg_dat:= round(sum / WidthPattern_pat);
//    
   sum:=0;
   DFT.fint.Seek(n*Sr, soFromBeginning);
   Pattern_int.Seek(0, soFromBeginning);
   for pn:=0 to WidthPattern_pat-1 do
    begin
     DFT.fint.ReadBuffer(pr_int,Sr);
     Pattern_int.ReadBuffer(pat_int,Sr);
     mx:=pr_int - avg_dat;
     my:=pat_int - avg_pat;
     sum:=sum + mx*my;
     dx:=dx+mx*mx;
     dy:=dy+my*my;
    end;
    if (dx=0) or (dy=0) then
      cov :=0 else  cov:= round(sum /(sqrt(dx)*sqrt(dy))*100);//   

    ChartF.Series[1].AddXY(n,cov,st);
  end;


end;


procedure TForm1.ButtonStartPatKorClick(Sender: TObject);
begin
   if (not FaktPrepareFint) or (not FaktPrepareFPat) then
   begin
    StatusBar1.Panels[2].Text:='  ';
    exit;
   end else  StatusBar1.Panels[2].Text:='';
   if WidthPattern_pat = 0 then WidthPattern_pat:=1;
   if DFT.nmax <= WidthPattern_pat then
   begin
    StatusBar1.Panels[2].Text:='   ';
    exit;
   end;

   ChartF.Series[1].Clear;
   PirsonCorrelation;
//      WidthPattern_avto   

end;


procedure TForm1.ButtonStartAutoKorClick(Sender: TObject);
var cod:integer;
pr:longint;
begin
   if not FaktPrepareFint then
   begin
    StatusBar1.Panels[2].Text:='  ';
    exit;
   end else  StatusBar1.Panels[2].Text:='';

   Val(EditStartPattern.Text,pr,cod);
   if cod = 0 then StartPattern:=pr else StartPattern:=0;
   Val(EditWidthPattern.Text,pr,cod);
   if cod = 0 then WidthPattern_avto:=pr else WidthPattern_avto:=1;
   if WidthPattern_avto = 0 then WidthPattern_avto:=1;

   if StartPattern+WidthPattern_avto > DFT.nmax then
   begin
    StartPattern:=0;
    WidthPattern_avto:=1;
//    StatusBar1.Panels[2].Text:=' ';
   end;


   ChartF.Series[1].Clear;
   SamplCorrelation;
end;

procedure TForm1.SamplCorrelation;

//Cov(XY) =  1/n * Sum( (X(n)-U(x))*(Y(n)-U(y)))
// n -  
// Sum - 
// X(n) - n-   1
// Y(n) - n-   2
// U(x) -   1
// U(y) -   2


var
 n:longint;
 pn:integer;
 pr_int,pat_int:integer;
 Sr:integer;
 sum,dx,dy,mx,my:longint;
 cov:integer;
 cor:real;
 st:string;

 avg_dat:longint;

begin

//  
 st:='';
 Sr:=sizeof(pr_int);
 Pattern.Seek(0, soFromBeginning);
 DFT.fint.Seek(StartPattern*Sr,soFromBeginning);
 sum:=0;

 for n:=0 to WidthPattern_avto-1 do
  begin
   DFT.fint.ReadBuffer(pr_int,Sr);
   Pattern.WriteBuffer(pr_int,Sr);
   sum:=sum + pr_int;
  end;
 avg_pat:=round(sum / WidthPattern_avto);
//  ,   

 Pattern.Seek(0, soFromBeginning);

 for n:=0 to DFT.nmax-WidthPattern_avto do
  begin
   sum:=0;
   dx:=0;
   dy:=0;
   DFT.fint.Seek(n*Sr, soFromBeginning);
   for pn:=0 to WidthPattern_avto-1 do
    begin
     DFT.fint.ReadBuffer(pr_int,Sr);
     sum:=sum + pr_int;
    end;
   avg_dat:= round(sum / WidthPattern_avto);
//    
   sum:=0;
   DFT.fint.Seek(n*Sr, soFromBeginning);
   Pattern.Seek(0, soFromBeginning);
   for pn:=0 to WidthPattern_avto-1 do
    begin
     DFT.fint.ReadBuffer(pr_int,Sr);
     Pattern.ReadBuffer(pat_int,Sr);
     mx:=pr_int - avg_dat;
     my:=pat_int - avg_pat;
     sum:=sum + mx*my;
     dx:=dx+mx*mx;
     dy:=dy+my*my;
    end;
    if (dx=0) or (dy=0) then
      cov :=0 else  cov:= round(sum /(sqrt(dx)*sqrt(dy))*100);//   

    ChartF.Series[1].AddXY(n,cov,st);
  end;


end;

procedure TForm1.CheckBoxMarkClick(Sender: TObject);
begin
// ChartF.Series[0].Marks.visible:=CheckBoxMark.Checked;
end;

procedure TForm1.Series2Click(Sender: TChartSeries; ValueIndex: Integer;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
  var st:string;
begin
 st:= 'X: '+inttostr(ValueIndex)+'  Y:'+ floattostr(ChartF.Series[0].YValue[ValueIndex]);
 StatusBar1.Panels[2].Text:=st;
 ChartF.Hint:=st;
 ChartF.ShowHint:=true;
 Application.ShowHint := True;
end;

procedure TForm1.Series3Click(Sender: TChartSeries; ValueIndex: Integer;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
 var st:string;
begin
 st:= 'X: '+inttostr(ValueIndex)+'  Y:'+ floattostr(ChartF.Series[1].YValue[ValueIndex]);
 StatusBar1.Panels[2].Text:=st;
 ChartF.Hint:=st;
 ChartF.ShowHint:=true;
 Application.ShowHint := True;

end;

procedure TForm1.CheckBoxViewFClick(Sender: TObject);
begin

 if Not CheckBoxViewF.checked then
  begin
   Series2.LinePen.Style:=psClear;
   Series2.Pointer.Visible:=false;
  end else
  begin
   Series2.LinePen.Style:=psSolid;
   Series2.Pointer.Visible:=true;
  end;
end;
procedure TForm1.CheckBoxViewPatClick(Sender: TObject);
begin
 if Not CheckBoxViewPat.checked then
  begin
   Series4.LinePen.Style:=psClear;
   Series4.Pointer.Visible:=false;
  end else
  begin
   Series4.LinePen.Style:=psSolid;
   Series4.Pointer.Visible:=true;
  end;
end;

procedure TForm1.CheckBoxViewSClick(Sender: TObject);
begin

 if Not CheckBoxViewS.checked then
  begin
   Series3.LinePen.Style:=psClear;
   Series3.Pointer.Visible:=false;
  end else
  begin
   Series3.LinePen.Style:=psSolid;
   Series3.Pointer.Visible:=true;
  end;

end;

procedure TForm1.NAboutClick(Sender: TObject);
const
  InfoNum = 10;
  InfoStr: array[1..InfoNum] of string = ('CompanyName', 'FileDescription', 'FileVersion', 'InternalName', 'LegalCopyright', 'LegalTradeMarks', 'OriginalFileName', 'ProductName', 'ProductVersion', 'Comments');
  InfoStrRus: array[1..InfoNum] of string = ('', '', ' ', ' ', '', ' ', 'OriginalFileName', '', ' ', '');
var
  S: string;
  n, Len, i: DWORD;
  Buf: PChar;
  Value: PChar;
  Ver: cardinal;
begin
//  ShellExecute (Form1.Handle, nil, 'opera', 'http://www.keklab.ru/frees.html', nil, SW_RESTORE); //   
  ShellExecute (Form1.Handle, nil,'iexplore','http://www.keklab.ru/frees.html', nil, SW_RESTORE); //   
  PanelAbout.Top:=(PanelMain.height - PanelAbout.Height) div 2;
  PanelAbout.left:=(PanelMain.width - PanelAbout.width) div 2;
  PanelAbout.Visible:=true;
  PanelAbout.BringToFront;
  S := Application.ExeName;
  Ver := GetFileVersion(S);
 // Memo1.Lines.Add('Version ' + IntToHex(Ver shr 16, 2) + '.' + IntToHex(Ver shr 24, 2));}

  n := GetFileVersionInfoSize(PChar(S), n);
  if n > 0 then
  begin
    Buf := AllocMem(n);
   // Memo1.Lines.Add('VersionInfoSize = ' + IntToStr(n));
    GetFileVersionInfo(PChar(S), 0, n, Buf);
    for i := 1 to InfoNum do
      if VerQueryValue(Buf, PChar('\StringFileInfo\041904E3\' + InfoStr[i]), Pointer(Value), Len) then
        if Length(Value) > 0 then
          Memo1.Lines.Add(InfoStrRus[i] + ': ' + Value);
    Memo1.Lines.Add('http://www.keklab.ru');
    FreeMem(Buf, n);
  end
  else
    Memo1.Lines.Add('No version information found');

end;

procedure TForm1.Button1Click(Sender: TObject);
begin
 PanelAbout.Visible:=false;
end;

procedure TForm1.Export_res(ff:integer);
var
  f: TextFile;
  i, j, n,n1,n2,n3: integer;
  ods: char;
  stf:string;

begin

   case ff of
    0: stf:='export_spectr.dat';
    1: stf:='export_korr.dat';
   end;

   AssignFile(f, stf);
   Rewrite(f);

   case ff of
    0:
      begin
        if ChartSpectr.SeriesCount > 0 then
          begin
            Write (f, ''+#9);
            Write (f, ''+#9);
            Write (f, ''+#9);
            writeln(f);
            n := ChartSpectr.Series[0].Count;

            for i := 0 to n-1 do
            begin
              Write(f, Format('%0.0f',[ChartSpectr.Series[0].XValues[i]]));
              Write(f, #9+ChartSpectr.Series[0].XLabel[i]);
              for j := 0 to ChartSpectr.SeriesCount-1 do
                with ChartSpectr.Series[j] do
                begin
                 Write(f, #9+Format('%0.1f',[YValues[i]]));
                end;
              WriteLn(f);
            end;
          end;

          CloseFile(f);
      end;
    1:
      begin
        if ChartF.SeriesCount > 0 then
          begin
            Write (f, ''+#9);
            Write (f, ''+#9);
            Write (f, ''+#9);
            writeln(f);

            n1 := ChartF.Series[0].Count;
            n2 := ChartF.Series[1].Count;
            n3 := ChartF.Series[2].Count;

            if n1>n2 then n:=n1 else n:=n2;
            if n<n3 then n:=n3;

            for i := 0 to n-1 do
            begin
              Write(f, Format('%0.0f',[ChartF.Series[0].YValues[i]]));
              Write(f,#9);
              if (n2 > 0) then
                if (i < n2) then Write(f, Format('%0.0f',[ChartF.Series[1].YValues[i]]));
              Write(f,#9);
              if (n3 > 0) then
                if (i < n3) then Write(f, Format('%0.0f',[ChartF.Series[2].YValues[i]]));
              WriteLn(f);
            end;
          end;

          CloseFile(f);

      end;
   end;







 end;


procedure TForm1.NKorrClick(Sender: TObject);
begin
 Export_res(1);
end;


procedure TForm1.NSpectrClick(Sender: TObject);
begin
 Export_res(0);
end;



procedure TForm1.NGenClick(Sender: TObject);
var n:integer;
countdat:integer;
noisedat:integer;
y:real;
rand_ampl:integer;
st:string;
begin
  countdat:=2000;
  RichEdit1.Clear;
  randomize;
  rand_ampl:=10;
  for n:=1 to countdat do
  begin
     y:=sin(n/20) + random(rand_ampl)/rand_ampl/2 + (countdat-n)/countdat*2*cos(n/100+2);
     st:=FormatFloat('0.000',y);
     RichEdit1.Lines.Add(st);

  end;


end;

procedure TForm1.CheckBoxViewPatKorClick(Sender: TObject);
begin
 if Not CheckBoxViewPatKor.checked then
  begin
   Series3.LinePen.Style:=psClear;
   Series3.Pointer.Visible:=false;
  end else
  begin
   Series3.LinePen.Style:=psSolid;
   Series3.Pointer.Visible:=true;
  end;

end;



end.
